# builds the index

import os

def overwriteifmodified(filename, s):
    try:
        f = open(filename, 'r')
        current = f.read()
        f.close()
    except Exception:
        current = ''
    if s != current:
        f = open(filename, 'w')
        f.write(s)
        f.close()

inittags = parser.gettags()
parser.settags(inittags.copy())
list_tree = []
cutlen = len(os.getcwd()) + 1
for root, dirs, files in os.walk(os.getcwd()):
    for f in files:
        if not f.endswith('.epp'):
            continue
        infname = os.path.join(root, f)
        inf = open(infname, 'r')
        instr = inf.read()
        inf.close()
        if '[define list_title="' in instr:
            parser.parsetags(instr)
            list_tree.append((infname[cutlen:-4], 
                             parser.parsetags('[list_title]'),
                             parser.parsetags('[list_desc]')))
            parser.settags(inittags.copy())
parser.settags(inittags)
codes_list = []
projects_list = []
for root, title, desc in list_tree:
    li = '<li><a href="[base_address]%s">%s</a> - %s</li>' % (root, title, desc)
    if root.startswith('codes'):
        codes_list.append(li)
    elif root.startswith('projects'):
        projects_list.append(li)
codes_list.sort()
projects_list.sort()
codes_list_eppd = '[define codes_list:]\n\t<ul>' + \
                  '\n\t'.join(codes_list) + '</ul>'
projects_list_eppd = '[define projects_list:]\n\t<ul>' + \
                     '\n\t'.join(projects_list) + '</ul>'
overwriteifmodified('codes_list.eppd', codes_list_eppd)
overwriteifmodified('projects_list.eppd', projects_list_eppd)
    



